#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

#define PI 3.141592653589793
#define sqrt2 1.414213562373
#define oneoversqrt2 0.707106781186
#define fillincrement 0.01

float delrho,alpha,*load,**erode,**slope,S,averosionrate,avreboundrate,avelevation;
float oneoverdeltax,oneoverdeltax2,**U,K,D,X,duration,timestep;
float *topovec,thresh,**deltah,**channel,**area,**sedflux,**sedfluxold,**flow1;
float **flow2,**flow3,**flow4,**flow5,**flow6,**flow7,**flow8,**flow,**topo,**topoold;
float **topo2,deltax,*ax,*ay,*bx,*by,*cx,*cy,*ux,*uy,*rx,*ry;
int *nn,*topovecind,lattice_size_x,lattice_size_y,*iup,*idown,*jup,*jdown;

void setupgridneighbors()
{    int i,j;

     idown=ivector(1,lattice_size_x);
     iup=ivector(1,lattice_size_x);
     jup=ivector(1,lattice_size_y);
     jdown=ivector(1,lattice_size_y);
     for (i=1;i<=lattice_size_x;i++)
      {idown[i]=i-1;
       iup[i]=i+1;}
     idown[1]=1;
     iup[lattice_size_x]=lattice_size_x;
     for (j=1;j<=lattice_size_y;j++)
      {jdown[j]=j-1;
       jup[j]=j+1;}
     jdown[1]=1;
     jup[lattice_size_y]=lattice_size_y;
}

void fillinpitsandflats(i,j)
int i,j;
{    float min;

     min=topo[i][j];
     if (topo[iup[i]][j]<min) min=topo[iup[i]][j];
     if (topo[idown[i]][j]<min) min=topo[idown[i]][j];
     if (topo[i][jup[j]]<min) min=topo[i][jup[j]];
     if (topo[i][jdown[j]]<min) min=topo[i][jdown[j]];
     if (topo[iup[i]][jup[j]]<min) min=topo[iup[i]][jup[j]];
     if (topo[idown[i]][jup[j]]<min) min=topo[idown[i]][jup[j]];
     if (topo[idown[i]][jdown[j]]<min) min=topo[idown[i]][jdown[j]];
     if (topo[iup[i]][jdown[j]]<min) min=topo[iup[i]][jdown[j]];
     if ((topo[i][j]<=min)&&(i>1)&&(j>1)&&(i<lattice_size_x)&&(j<lattice_size_y))
      {topo[i][j]=min+fillincrement;
       fillinpitsandflats(i,j);
       fillinpitsandflats(iup[i],j);
       fillinpitsandflats(idown[i],j);
       fillinpitsandflats(i,jup[j]);
       fillinpitsandflats(i,jdown[j]);
       fillinpitsandflats(iup[i],jup[j]);
       fillinpitsandflats(idown[i],jup[j]);
       fillinpitsandflats(idown[i],jdown[j]);
       fillinpitsandflats(iup[i],jdown[j]);}
}

void mfdflowroute(i,j)
int i,j;
{    float tot;

     tot=0;
     if (topo[i][j]>topo[iup[i]][j])
      tot+=pow(topo[i][j]-topo[iup[i]][j],1.1);
     if (topo[i][j]>topo[idown[i]][j])
      tot+=pow(topo[i][j]-topo[idown[i]][j],1.1);
     if (topo[i][j]>topo[i][jup[j]])
      tot+=pow(topo[i][j]-topo[i][jup[j]],1.1);
     if (topo[i][j]>topo[i][jdown[j]])
      tot+=pow(topo[i][j]-topo[i][jdown[j]],1.1);
     if (topo[i][j]>topo[iup[i]][jup[j]])
      tot+=pow((topo[i][j]-topo[iup[i]][jup[j]])*oneoversqrt2,1.1);
     if (topo[i][j]>topo[iup[i]][jdown[j]])
      tot+=pow((topo[i][j]-topo[iup[i]][jdown[j]])*oneoversqrt2,1.1);
     if (topo[i][j]>topo[idown[i]][jup[j]])
      tot+=pow((topo[i][j]-topo[idown[i]][jup[j]])*oneoversqrt2,1.1);
     if (topo[i][j]>topo[idown[i]][jdown[j]])
      tot+=pow((topo[i][j]-topo[idown[i]][jdown[j]])*oneoversqrt2,1.1);
     if (topo[i][j]>topo[iup[i]][j])
      flow1[i][j]=pow(topo[i][j]-topo[iup[i]][j],1.1)/tot;
       else flow1[i][j]=0;
     if (topo[i][j]>topo[idown[i]][j])
      flow2[i][j]=pow(topo[i][j]-topo[idown[i]][j],1.1)/tot;
       else flow2[i][j]=0;
     if (topo[i][j]>topo[i][jup[j]])
      flow3[i][j]=pow(topo[i][j]-topo[i][jup[j]],1.1)/tot;
       else flow3[i][j]=0;
     if (topo[i][j]>topo[i][jdown[j]])
      flow4[i][j]=pow(topo[i][j]-topo[i][jdown[j]],1.1)/tot;
       else flow4[i][j]=0;
     if (topo[i][j]>topo[iup[i]][jup[j]])
      flow5[i][j]=pow((topo[i][j]-topo[iup[i]][jup[j]])*oneoversqrt2,1.1)/tot;
       else flow5[i][j]=0;
     if (topo[i][j]>topo[iup[i]][jdown[j]])
      flow6[i][j]=pow((topo[i][j]-topo[iup[i]][jdown[j]])*oneoversqrt2,1.1)/tot;
       else flow6[i][j]=0;
     if (topo[i][j]>topo[idown[i]][jup[j]])
      flow7[i][j]=pow((topo[i][j]-topo[idown[i]][jup[j]])*oneoversqrt2,1.1)/tot;
       else flow7[i][j]=0;
     if (topo[i][j]>topo[idown[i]][jdown[j]])
      flow8[i][j]=pow((topo[i][j]-topo[idown[i]][jdown[j]])*oneoversqrt2,1.1)/tot;
       else flow8[i][j]=0;
     flow[iup[i]][j]+=flow[i][j]*flow1[i][j];
     flow[idown[i]][j]+=flow[i][j]*flow2[i][j];
     flow[i][jup[j]]+=flow[i][j]*flow3[i][j];
     flow[i][jdown[j]]+=flow[i][j]*flow4[i][j];
     flow[iup[i]][jup[j]]+=flow[i][j]*flow5[i][j];
     flow[iup[i]][jdown[j]]+=flow[i][j]*flow6[i][j];
     flow[idown[i]][jup[j]]+=flow[i][j]*flow7[i][j];
     flow[idown[i]][jdown[j]]+=flow[i][j]*flow8[i][j];
}

void calculatealongchannelslope(i,j)
int i,j;
{    float down;

     down=0;
     if (topo[iup[i]][j]-topo[i][j]<down) down=topo[iup[i]][j]-topo[i][j];
     if (topo[idown[i]][j]-topo[i][j]<down) down=topo[idown[i]][j]-topo[i][j];
     if (topo[i][jup[j]]-topo[i][j]<down) down=topo[i][jup[j]]-topo[i][j];
     if (topo[i][jdown[j]]-topo[i][j]<down) down=topo[i][jdown[j]]-topo[i][j];
     if ((topo[iup[i]][jup[j]]-topo[i][j])*oneoversqrt2<down)
      down=(topo[iup[i]][jup[j]]-topo[i][j])*oneoversqrt2;
     if ((topo[idown[i]][jup[j]]-topo[i][j])*oneoversqrt2<down)
      down=(topo[idown[i]][jup[j]]-topo[i][j])*oneoversqrt2;
     if ((topo[iup[i]][jdown[j]]-topo[i][j])*oneoversqrt2<down)
      down=(topo[iup[i]][jdown[j]]-topo[i][j])*oneoversqrt2;
     if ((topo[idown[i]][jdown[j]]-topo[i][j])*oneoversqrt2<down)
      down=(topo[idown[i]][jdown[j]]-topo[i][j])*oneoversqrt2;
     slope[i][j]=fabs(down)/deltax;
}

void computeflexure()
{    int i,j,index;
     float fact;

     for (j=1;j<=lattice_size_y;j++)
       for (i=1;i<=lattice_size_x;i++)
        {load[2*(i-1)*lattice_size_y+2*j-1]=erode[i][j];
         load[2*(i-1)*lattice_size_y+2*j]=0.0;}
     fourn(load,nn,2,1);
     load[1]*=1/delrho;
     load[2]*=1/delrho;
     for (j=1;j<=lattice_size_y/2;j++)
       {fact=1/(delrho+4*delrho*pow(alpha*j*PI/lattice_size_y,4.0));
        load[2*j+1]*=fact;
        load[2*j+2]*=fact;
        load[2*lattice_size_y-2*j+1]*=fact;
        load[2*lattice_size_y-2*j+2]*=fact;}
     for (i=1;i<=lattice_size_x/2;i++)
       {fact=1/(delrho+4*delrho*pow(alpha*i*PI/lattice_size_x,4.0));
        load[2*i*lattice_size_y+1]*=fact;
        load[2*i*lattice_size_y+2]*=fact;
        load[2*lattice_size_x*lattice_size_y-2*i*lattice_size_y+1]*=fact;
        load[2*lattice_size_x*lattice_size_y-2*i*lattice_size_y+2]*=fact;}
     for (i=1;i<=lattice_size_x/2;i++)
       for (j=1;j<=lattice_size_y/2;j++)
         {fact=1/(delrho+4*delrho*pow(alpha*sqrt((PI*PI*i*i)/(lattice_size_x*lattice_size_x)
        +(PI*PI*j*j)/(lattice_size_y*lattice_size_y)),4.0));
          index=2*i*lattice_size_y+2*j+1;
          load[index]*=fact;
          load[index+1]*=fact;
          index=2*i*lattice_size_y+2*lattice_size_y-2*j+1;
          load[index]*=fact;
          load[index+1]*=fact;
          index=2*lattice_size_x*lattice_size_y-2*(i-1)*lattice_size_y-2*(lattice_size_y-j)+1;
          load[index]*=fact;
          load[index+1]*=fact;
          index=2*lattice_size_x*lattice_size_y-2*lattice_size_y-
           2*(i-1)*lattice_size_y+2*(lattice_size_y-j)+1;
          load[index]*=fact;
          load[index+1]*=fact;}
     fourn(load,nn,2,-1);
     for (j=2;j<=lattice_size_y-1;j++)
       for (i=2;i<=lattice_size_x-1;i++)
        {U[i][j]=delrho*(1-delrho)*load[2*(i-1)*lattice_size_y+2*j-1]
          /(lattice_size_x*lattice_size_y);}
}

void setupmatrices()
{    int i,j;

     ax=vector(1,lattice_size_x);
     ay=vector(1,lattice_size_y);
     bx=vector(1,lattice_size_x);
     by=vector(1,lattice_size_y);
     cx=vector(1,lattice_size_x);
     cy=vector(1,lattice_size_y);
     ux=vector(1,lattice_size_x);
     uy=vector(1,lattice_size_y);
     rx=vector(1,lattice_size_x);
     ry=vector(1,lattice_size_y);
     topo=matrix(1,lattice_size_x,1,lattice_size_y);
     topo2=matrix(1,lattice_size_x,1,lattice_size_y);
     topoold=matrix(1,lattice_size_x,1,lattice_size_y);
     sedflux=matrix(1,lattice_size_x,1,lattice_size_y);
     sedfluxold=matrix(1,lattice_size_x,1,lattice_size_y);
     area=matrix(1,lattice_size_x,1,lattice_size_y);
     slope=matrix(1,lattice_size_x,1,lattice_size_y);
     deltah=matrix(1,lattice_size_x,1,lattice_size_y);
     load=vector(1,2*lattice_size_x*lattice_size_y);
     erode=matrix(1,lattice_size_x,1,lattice_size_y);
     U=matrix(1,lattice_size_x,1,lattice_size_y);
     channel=matrix(1,lattice_size_x,1,lattice_size_y);
     flow=matrix(1,lattice_size_x,1,lattice_size_y);
     flow1=matrix(1,lattice_size_x,1,lattice_size_y);
     flow2=matrix(1,lattice_size_x,1,lattice_size_y);
     flow3=matrix(1,lattice_size_x,1,lattice_size_y);
     flow4=matrix(1,lattice_size_x,1,lattice_size_y);
     flow5=matrix(1,lattice_size_x,1,lattice_size_y);
     flow6=matrix(1,lattice_size_x,1,lattice_size_y);
     flow7=matrix(1,lattice_size_x,1,lattice_size_y);
     flow8=matrix(1,lattice_size_x,1,lattice_size_y);
     topovec=vector(1,lattice_size_x*lattice_size_y);
     topovecind=ivector(1,lattice_size_x*lattice_size_y);
}

main()
{    FILE *fp0,*fp1,*fp2,*fp3,*fp4,*fp5;
     float change,maxelevation,capacity,time,max,hillslopeerosionrate;
     int printinterval,i,j,t;

     fp0=fopen("sedfluxdriventopoinitial","r");
     fp1=fopen("sedfluxdriventopo","w");
     fp2=fopen("sedfluxdrivenerosion","w");
     fp3=fopen("sedfluxdrivensedflux","w");
     fp4=fopen("sedfluxdrivenrebound","w");
     fp5=fopen("modeltimehistory","w");
     lattice_size_x=256;
     lattice_size_y=256;
     deltax=500;   /* m */
     delrho=0.28;  /* (rho_m-rho_c)/rho_c */
     oneoverdeltax=1.0/deltax;
     oneoverdeltax2=1.0/(deltax*deltax);
     timestep=1.0; /* kyr */
     alpha=200;    /* multiples of deltax */
     hillslopeerosionrate=0.01; /* m/kyr */
     K=0.0005;     /* m^1/2/kyr */
     D=1.0;        /* m^2/kyr */
     X=0.005;      /* m^-1 */
     alpha/=deltax;
     setupmatrices();
     setupgridneighbors();
     for (j=1;j<=lattice_size_y;j++)
      for (i=1;i<=lattice_size_x;i++)
       {fscanf(fp0,"%f",&topo[i][j]);topo[i][j]/=5;
        if ((i==1)||(j==1)||(i==lattice_size_x)||(j==lattice_size_y)) topo[i][j]=0;
        topoold[i][j]=topo[i][j];
        flow[i][j]=deltax*deltax;
        area[i][j]=0;
        U[i][j]=0;
        erode[i][j]=0;
        channel[i][j]=0;
        sedflux[i][j]=0;
        sedfluxold[i][j]=0;}
     time=0;
     nn=ivector(1,2);
     nn[1]=lattice_size_x;
     nn[2]=lattice_size_y;
     duration=40000;         /* 40 Myr */
     printinterval=40000;
     while (time<duration)
      {for (j=1;j<=lattice_size_y;j++)
        for (i=1;i<=lattice_size_x;i++)
         topoold[i][j]=topo[i][j];
       /*compute uplift rate*/
       if (time>1000) computeflexure();  /* compute isostatic uplift */
       else
        {/* or prescribe a tectonic uplift rate */
         for (j=2;j<=lattice_size_y-1;j++)
          for (i=2;i<=lattice_size_x-1;i++)
           U[i][j]=1.0;  /* m/kyr */}
       avelevation=0;avreboundrate=0;maxelevation=0;
       for (j=2;j<=lattice_size_y-1;j++)
        for (i=2;i<=lattice_size_x-1;i++)
         {avelevation+=topo[i][j];
          if (topo[i][j]>maxelevation) maxelevation=topo[i][j];
          avreboundrate+=U[i][j];
          topoold[i][j]+=U[i][j]*timestep;
          topo[i][j]+=U[i][j]*timestep;
          deltah[i][j]=0;
          channel[i][j]=0;}
       avelevation/=(lattice_size_x-2)*(lattice_size_y-2);
       avreboundrate/=(lattice_size_x-2)*(lattice_size_y-2);
       printf("%f %f %f %f %f\n",time,avelevation,averosionrate,avreboundrate,maxelevation);
       fprintf(fp5,"%f %f %f %f %f\n",time,avelevation,averosionrate,avreboundrate,maxelevation);
       /* hillslope erosion can occur by prescribing a uniform rate, as done here
	      or using the ADI technique to solve the diffusion equation on hillslopes */
       for (j=2;j<=lattice_size_y-1;j++)
        for (i=2;i<=lattice_size_x-1;i++)
         if (channel[i][j]==0) topo[i][j]-=hillslopeerosionrate*timestep;
       for (j=2;j<=lattice_size_y-1;j++)
        for (i=2;i<=lattice_size_x-1;i++)
         erode[i][j]=(topoold[i][j]-topo[i][j])/timestep;
       for (j=1;j<=lattice_size_y;j++)
        for (i=1;i<=lattice_size_x;i++)
         fillinpitsandflats(i,j);
       /*route water from highest gridpoint to lowest*/
       for (j=1;j<=lattice_size_y;j++)
        for (i=1;i<=lattice_size_x;i++)
         flow[i][j]=deltax*deltax;
       for (j=1;j<=lattice_size_y;j++)
        for (i=1;i<=lattice_size_x;i++)
         topovec[(j-1)*lattice_size_x+i]=topo[i][j];
       indexx(lattice_size_x*lattice_size_y,topovec,topovecind);
       t=lattice_size_x*lattice_size_y+1;
       while (t>1)
        {t--;
         i=(topovecind[t])%lattice_size_x;
         if (i==0) i=lattice_size_x;
         j=(topovecind[t])/lattice_size_x+1;
         if (i==lattice_size_x) j--;
         mfdflowroute(i,j);}
       for (i=2;i<=lattice_size_x-1;i++)
        for (j=2;j<=lattice_size_y-1;j++)
         area[i][j]=flow[i][j];
       /*perform upwind differencing */
       max=0;
       for (i=2;i<=lattice_size_x-1;i++)
        for (j=2;j<=lattice_size_y-1;j++)
         {calculatealongchannelslope(i,j);
          capacity=slope[i][j]*sqrt(area[i][j]);
          if (capacity>1/X)
           {change=timestep*K*sqrt(fabs(sedflux[i][j]))*deltax*slope[i][j];
            deltah[i][j]+=change;
            erode[i][j]+=change/timestep;
            if (deltah[i][j]<0) deltah[i][j]=0;
            channel[i][j]=1;}
          topo[i][j]-=deltah[i][j];
          if (topo[i][j]<0) topo[i][j]=0;
          if (K*sqrt(fabs(sedflux[i][j]))*deltax>max)
           max=K*sqrt(fabs(sedflux[i][j]))*deltax;}
       for (j=1;j<=lattice_size_y;j++)
        for (i=1;i<=lattice_size_x;i++)
         fillinpitsandflats(i,j);
       averosionrate=0;
       for (i=2;i<=lattice_size_x-1;i++)
        for (j=2;j<=lattice_size_y-1;j++)
         {flow[i][j]=erode[i][j];
          averosionrate+=erode[i][j];}
       averosionrate/=(lattice_size_x-2)*(lattice_size_y-2);
       for (j=1;j<=lattice_size_y;j++)
        for (i=1;i<=lattice_size_x;i++)
         topovec[(j-1)*lattice_size_x+i]=topo[i][j];
       indexx(lattice_size_x*lattice_size_y,topovec,topovecind);
       t=lattice_size_x*lattice_size_y+1;
       while (t>1)
        {t--;
         i=(topovecind[t])%lattice_size_x;
         if (i==0) i=lattice_size_x;
         j=(topovecind[t])/lattice_size_x+1;
         if (i==lattice_size_x) j--;
         mfdflowroute(i,j);}
       for (i=2;i<=lattice_size_x-1;i++)
        for (j=2;j<=lattice_size_y-1;j++)
         {sedfluxold[i][j]=sedflux[i][j];
          sedflux[i][j]=flow[i][j];}
       time+=timestep;
       if (max>5.0*deltax/timestep)
        {time-=timestep;
         timestep/=2.0;
         for (i=2;i<=lattice_size_x-1;i++)
          for (j=2;j<=lattice_size_y-1;j++)
           {sedflux[i][j]=sedfluxold[i][j];
            topo[i][j]=topoold[i][j]-U[i][j]*timestep;}}
        else
         {if (max<0.5*deltax/timestep) timestep*=1.2;}
       if (time>=printinterval)
        {printinterval+=40000;
         for (i=1;i<=lattice_size_x;i++)
          for (j=1;j<=lattice_size_y;j++)
           {fprintf(fp1,"%f\n",topo[i][j]);
            fprintf(fp2,"%f\n",erode[i][j]);
            fprintf(fp3,"%f\n",sedflux[i][j]);
            fprintf(fp4,"%f\n",U[i][j]);}}}
}
