#include<malloc.h>
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include"nr.h"
#include"nrutil.h"

#define fillincrement 0.1

float taugam,**topo,block,*heightvec,**mask,**height,delta;
int *heightvecind,*iup,*jup,*idown,*jdown,lattice_size_x,lattice_size_y,change;

void setupgridneighbors()
{    int i,j;

     idown=ivector(1,lattice_size_x);
     iup=ivector(1,lattice_size_x);
     jup=ivector(1,lattice_size_y);
     jdown=ivector(1,lattice_size_y);
     for (i=1;i<=lattice_size_x;i++)
      {idown[i]=i-1;
       iup[i]=i+1;}
     idown[1]=1;
     iup[lattice_size_x]=lattice_size_x;
     for (j=1;j<=lattice_size_y;j++)
      {jdown[j]=j-1;
       jup[j]=j+1;}
     jdown[1]=1;
     jup[lattice_size_y]=lattice_size_y;
}

void addiflessthanthreshold(i,j)
int i,j;
{    float slope,slopex,slopey; 

     height[i][j]+=block;
     slopex=height[i][j]-height[iup[i]][j];
     if (height[i][j]-height[idown[i]][j]>slopex) slopex=height[i][j]-height[idown[i]][j];
     slopey=height[i][j]-height[i][jup[j]];
     if (height[i][j]-height[i][jdown[j]]>slopey) slopey=height[i][j]-height[i][jdown[j]];
     slope=sqrt(slopex*slopex+slopey*slopey)/delta; 
     /* this version implements slope-dependent threshold 
           tau(S)=15S^0.55 */
     if (pow(slope,0.45)*(height[i][j]-topo[i][j])>taugam*15)
      height[i][j]-=block;
     else change=1;
}

void checkmin(i,j)
int i,j;
{    float min;

     min=10000;
     if (mask[i][j]>0.1) {
     if (height[iup[i]][j]<min) min=height[iup[i]][j];
     if (height[idown[i]][j]<min) min=height[idown[i]][j];
     if (height[i][jup[j]]<min) min=height[i][jup[j]];
     if (height[i][jdown[j]]<min) min=height[i][jdown[j]];
     if (height[i][j]<min) {height[i][j]=min+0.1;
                            checkmin(iup[i],j);
                            checkmin(idown[i],j);
                            checkmin(i,jup[j]);
                            checkmin(i,jdown[j]);} }
}

main()
{    FILE *fp1,*fp2,*fp3;
     int i,j,t; 

     fp1=fopen("greenlandsmallbed","r");
     fp2=fopen("greenlandsmallmask","r");
     fp3=fopen("greenlandsmallsurf","w");
     lattice_size_x=150;
     lattice_size_y=280;
     delta=10000.0;                 /* km */
     taugam=100000.0/(920.0*9.8);   /* tau = 10^5 Pa */
     height=matrix(1,lattice_size_x,1,lattice_size_y);
     mask=matrix(1,lattice_size_x,1,lattice_size_y);
     topo=matrix(1,lattice_size_x,1,lattice_size_y);
     setupgridneighbors();
     heightvec=vector(1,lattice_size_x*lattice_size_y);
     heightvecind=ivector(1,lattice_size_x*lattice_size_y);
     for (j=1;j<=lattice_size_y;j++)
      for (i=1;i<=lattice_size_x;i++)
       {fscanf(fp1,"%f",&topo[i][j]);
        fscanf(fp2,"%f",&mask[i][j]);
        height[i][j]=topo[i][j];}
     block=100;             /* start at 100 m block size */
     while (block>0.9)      /* stop when block size < 1 m */
      {change=1;
       while (change>0)
        {change=0;
         for (j=1;j<=lattice_size_y;j++)
          for (i=1;i<=lattice_size_x;i++)
           heightvec[(j-1)*lattice_size_x+i]=height[i][j];
         indexx(lattice_size_x*lattice_size_y,heightvec,heightvecind);
         t=0;
         while (t<lattice_size_x*lattice_size_y)
          {t++;
           i=(heightvecind[t])%lattice_size_x;
           if (i==0) i=lattice_size_x;
           j=(heightvecind[t])/lattice_size_x+1;
           if (mask[i][j]>0.1)
            addiflessthanthreshold(i,j);}
         for (j=1;j<=lattice_size_y;j++)
          for (i=1;i<=lattice_size_x;i++)
           checkmin(i,j);}
       block=block/3.33;}
     for (j=1;j<=lattice_size_y;j++)
      for (i=1;i<=lattice_size_x;i++)
       {if (height[i][j]>0) 
         fprintf(fp3,"%f\n",height[i][j]);
	    else fprintf(fp3,"0\n");}
     fclose(fp1);
     fclose(fp2);
     fclose(fp3);
}  
